import { ParseTree, Parser } from './pasm';
declare class PExpr {
    cname(): string;
    minLen(): number;
}
declare class PRef extends PExpr {
    peg: Grammar;
    name: string;
    minlen: number | null;
    constructor(peg: Grammar, name: string);
    toString(): string;
    uname(peg?: Grammar): string;
    deref(): PExpr;
    minLen(): number;
}
export declare class Grammar {
    static ID: number;
    ns: string;
    names: string[];
    rules: {
        [key: string]: PExpr;
    };
    examples: [string, ParseTree][];
    constructor(source?: string);
    set(name: string, e: PExpr): void;
    get(name: string): PExpr;
    startName(): string;
    newRef(name: string, t?: ParseTree): PRef;
    generate(start?: string): Parser;
    toString(): string;
}
export {};
