"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Utilities from Python3 Porting
var pasm_1 = require("./pasm");
var tpeg_1 = require("./tpeg");
var PExpr = /** @class */ (function () {
    function PExpr() {
    }
    PExpr.prototype.cname = function () {
        return this.constructor.name;
    };
    PExpr.prototype.minLen = function () {
        return 0;
    };
    return PExpr;
}());
var PAny = /** @class */ (function (_super) {
    __extends(PAny, _super);
    function PAny() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PAny.prototype.toString = function () {
        return '.';
    };
    PAny.prototype.minLen = function () {
        return 1;
    };
    return PAny;
}(PExpr));
var PChar = /** @class */ (function (_super) {
    __extends(PChar, _super);
    function PChar(text) {
        var _this = _super.call(this) || this;
        _this.text = text;
        return _this;
    }
    PChar.prototype.toString = function () {
        return pasm_1.quote(this.text);
    };
    PChar.prototype.minLen = function () {
        return this.text.length;
    };
    return PChar;
}(PExpr));
var PRange = /** @class */ (function (_super) {
    __extends(PRange, _super);
    function PRange(chars, ranges) {
        var _this = _super.call(this) || this;
        _this.chars = chars;
        _this.ranges = ranges;
        return _this;
    }
    PRange.prototype.toString = function () {
        return pasm_1.keyRange(this.chars, this.ranges);
    };
    PRange.prototype.minLen = function () {
        return 1;
    };
    PRange.ESCTBL = {
        '\n': '\\n', '\t': '\\t', '\r': '\\r', '\v': '\\v', '\f': '\\f',
        '\\': '\\\\', ']': '\\]', '-': '\\-'
    };
    return PRange;
}(PExpr));
var PRef = /** @class */ (function (_super) {
    __extends(PRef, _super);
    function PRef(peg, name) {
        var _this = _super.call(this) || this;
        _this.minlen = null;
        _this.peg = peg;
        _this.name = name;
        return _this;
    }
    PRef.prototype.toString = function () {
        return this.name;
    };
    PRef.prototype.uname = function (peg) {
        if (this.peg === peg) {
            return this.name;
        }
        return "" + this.peg.ns + this.name;
    };
    PRef.prototype.deref = function () {
        return this.peg.get(this.name);
    };
    PRef.prototype.minLen = function () {
        if (!this.minlen) {
            this.minlen = 0;
            this.minlen = this.deref().minLen();
        }
        return this.minlen;
    };
    return PRef;
}(PExpr));
var PTuple = /** @class */ (function (_super) {
    __extends(PTuple, _super);
    function PTuple() {
        var es = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            es[_i] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.minlen = null;
        _this.es = es;
        return _this;
    }
    return PTuple;
}(PExpr));
var PSeq = /** @class */ (function (_super) {
    __extends(PSeq, _super);
    function PSeq() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PSeq.new = function () {
        var es = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            es[_i] = arguments[_i];
        }
        var ls = [];
        for (var _a = 0, es_1 = es; _a < es_1.length; _a++) {
            var e = es_1[_a];
            if (e === EMPTY)
                continue;
            if (ls.length === 0) {
                ls.push(e);
                continue;
            }
            var pe = ls[ls.length - 1];
            if (e instanceof PChar && pe instanceof PChar) {
                ls[ls.length - 1] = new PChar(pe.text + e.text);
                continue;
            }
            ls.push(e);
        }
        return ls.length === 1 ? ls[0] : new (PSeq.bind.apply(PSeq, __spreadArrays([void 0], ls)))();
    };
    PSeq.prototype.toString = function () {
        return this.es.map(function (e) { return grouping(e, function (x) { return x instanceof POre; }); }).join(' ');
    };
    PSeq.prototype.minLen = function () {
        if (!this.minlen) {
            var mlen = 0;
            for (var _i = 0, _a = this.es; _i < _a.length; _i++) {
                var e = _a[_i];
                mlen += e.minLen();
            }
            this.minlen = mlen;
        }
        return this.minlen;
    };
    return PSeq;
}(PTuple));
// def splitFixed(remains):
// fixed = []
// size = 0
// f || e in remains:
// if e instanceof Char):
//     size += len(e.text)
// fixed.push(e)
// elif e instanceof Range) || e instanceof Any):
// size += 1
// fixed.push(e)
// elif e instanceof And) || e instanceof Not):
// size += 0
// fixed.push(e)
//         else:
// break
// remains = remains[len(fixed):]
var PAlt = /** @class */ (function (_super) {
    __extends(PAlt, _super);
    function PAlt() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PAlt.prototype.toString = function () {
        return this.es.map(function (e) { return e.toString(); }).join(' | ');
    };
    return PAlt;
}(PTuple));
var POre = /** @class */ (function (_super) {
    __extends(POre, _super);
    function POre() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    POre.new = function () {
        var es = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            es[_i] = arguments[_i];
        }
        var choices = [];
        for (var _a = 0, es_2 = es; _a < es_2.length; _a++) {
            var e = es_2[_a];
            O2.appendChoice(choices, e);
        }
        return choices.length === 1 ? choices[0] : new (POre.bind.apply(POre, __spreadArrays([void 0], choices)))();
    };
    POre.prototype.toString = function () {
        return this.es.map(function (e) { return e.toString(); }).join(' / ');
    };
    POre.prototype.minLen = function () {
        if (!this.minlen) {
            var mlen = 0;
            for (var _i = 0, _a = this.es; _i < _a.length; _i++) {
                var e = _a[_i];
                mlen = Math.min(e.minLen(), mlen);
            }
            this.minlen = mlen;
        }
        return this.minlen;
    };
    POre.prototype.isDict = function () {
        for (var _i = 0, _a = this.es; _i < _a.length; _i++) {
            var e = _a[_i];
            if (!(e instanceof PChar)) {
                return false;
            }
        }
        return true;
    };
    POre.prototype.listDict = function () {
        var dic = this.es.map(function (e) { return (e instanceof PChar) ? e.text : ''; });
        var dic2 = [];
        for (var _i = 0, dic_1 = dic; _i < dic_1.length; _i++) {
            var s = dic_1[_i];
            if (s === '')
                break;
            dic2.push(s);
        }
        return dic2;
    };
    POre.prototype.trieDict = function (dic) {
        if (dic === undefined) {
            dic = this.listDict();
        }
        if ('' in dic || dic.length < 10) {
            return dic;
        }
        var d = {};
        for (var _i = 0, dic_2 = dic; _i < dic_2.length; _i++) {
            var s = dic_2[_i];
            var c = s[0];
            var s1 = s.slice(1);
            if (c in d) {
                var entry = d[c];
                if (typeof entry === 'string') {
                    d[c] = [entry, s1];
                }
                else {
                    entry.push(s1);
                }
            }
            else {
                d[c] = s1;
            }
        }
        return d;
    };
    return POre;
}(PTuple));
var O2 = /** @class */ (function () {
    function O2() {
    }
    O2.inline = function (pe) {
        var start = pe;
        while (pe instanceof PRef) {
            pe = pe.deref();
            if (pe instanceof PChar || pe instanceof PRange) {
                return pe;
            }
        }
        return start;
    };
    O2.isRange = function (e) {
        return (e instanceof PChar && e.text.length == 1) || (e instanceof PRange);
    };
    O2.mergeRange = function (e, e2) {
        var chars = '';
        var ranges = '';
        if (e instanceof PChar) {
            chars += e.text;
        }
        if (e2 instanceof PChar) {
            chars += e2.text;
        }
        if (e instanceof PRange) {
            chars += e.chars;
            ranges += e.ranges;
        }
        if (e2 instanceof PRange) {
            chars += e2.chars;
            ranges += e2.ranges;
        }
        return new PRange(chars, ranges);
    };
    O2.appendChoice = function (es, pe) {
        if (pe instanceof POre) {
            for (var _i = 0, _a = pe.es; _i < _a.length; _i++) {
                var e = _a[_i];
                O2.appendChoice(es, e);
            }
        }
        else if (es.length === 0) {
            es.push(pe);
        }
        else if (O2.isRange(es[es.length - 1]) && O2.isRange(pe)) {
            es[es.length - 1] = O2.mergeRange(es[es.length - 1], pe);
        }
        else if (es[es.length] !== EMPTY) {
            es.push(pe);
        }
    };
    O2.appendChoice2 = function (es, pe) {
        var start = pe;
        while (pe instanceof PRef) {
            pe = pe.deref();
        }
        if (pe instanceof POre) {
            for (var _i = 0, _a = pe.es; _i < _a.length; _i++) {
                var e = _a[_i];
                O2.appendChoice2(es, e);
            }
        }
        else if (pe instanceof PChar || pe instanceof PRange) {
            O2.appendChoice(es, pe);
        }
        else {
            O2.appendChoice(es, start);
        }
    };
    return O2;
}());
// def inline(pe):
var PUnary = /** @class */ (function (_super) {
    __extends(PUnary, _super);
    function PUnary(e) {
        var _this = _super.call(this) || this;
        _this.e = e;
        return _this;
    }
    PUnary.prototype.minLen = function () {
        return this.e.minLen();
    };
    return PUnary;
}(PExpr));
var PAnd = /** @class */ (function (_super) {
    __extends(PAnd, _super);
    function PAnd() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PAnd.prototype.toString = function () {
        return '&' + grouping(this.e, inUnary);
    };
    PAnd.prototype.minLen = function () {
        return 0;
    };
    return PAnd;
}(PUnary));
var PNot = /** @class */ (function (_super) {
    __extends(PNot, _super);
    function PNot() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PNot.prototype.toString = function () {
        return '!' + grouping(this.e, inUnary);
    };
    PNot.prototype.minLen = function () {
        return 0;
    };
    return PNot;
}(PUnary));
var PMany = /** @class */ (function (_super) {
    __extends(PMany, _super);
    function PMany() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PMany.prototype.toString = function () {
        return grouping(this.e, inUnary) + '*';
    };
    PMany.prototype.minLen = function () { return 0; };
    return PMany;
}(PUnary));
var PMany1 = /** @class */ (function (_super) {
    __extends(PMany1, _super);
    function PMany1() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PMany1.prototype.toString = function () {
        return grouping(this.e, inUnary) + '+';
    };
    return PMany1;
}(PUnary));
var POption = /** @class */ (function (_super) {
    __extends(POption, _super);
    function POption() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    POption.prototype.toString = function () {
        return grouping(this.e, inUnary) + '?';
    };
    POption.prototype.minLen = function () { return 0; };
    return POption;
}(PUnary));
var PNode = /** @class */ (function (_super) {
    __extends(PNode, _super);
    function PNode(e, tag, shift) {
        if (tag === void 0) { tag = ''; }
        if (shift === void 0) { shift = 0; }
        var _this = _super.call(this, e) || this;
        _this.tag = tag;
        _this.shift = shift;
        return _this;
    }
    PNode.prototype.toString = function () {
        return "{" + this.e + "  #" + this.tag + "}";
    };
    return PNode;
}(PUnary));
var PEdge = /** @class */ (function (_super) {
    __extends(PEdge, _super);
    function PEdge(edge, e) {
        var _this = _super.call(this, e) || this;
        _this.edge = edge;
        return _this;
    }
    PEdge.prototype.toString = function () {
        return this.edge + ': ' + grouping(this.e, inUnary);
    };
    return PEdge;
}(PUnary));
var PFold = /** @class */ (function (_super) {
    __extends(PFold, _super);
    function PFold(edge, e, tag, shift) {
        if (tag === void 0) { tag = ''; }
        if (shift === void 0) { shift = 0; }
        var _this = _super.call(this, e) || this;
        _this.tag = tag;
        _this.edge = edge;
        _this.shift = shift;
        return _this;
    }
    PFold.prototype.toString = function () {
        var edge = (this.edge !== '') ? this.edge + ": " : '';
        return edge + ": ^ {" + this.e + "  #" + this.tag + "}";
    };
    return PFold;
}(PUnary));
var PAbs = /** @class */ (function (_super) {
    __extends(PAbs, _super);
    function PAbs(e) {
        return _super.call(this, e) || this;
    }
    PAbs.prototype.toString = function () {
        return "@Abs(" + this.e + ")";
    };
    return PAbs;
}(PUnary));
var PAction = /** @class */ (function (_super) {
    __extends(PAction, _super);
    function PAction(e, func, params, t) {
        var _this = _super.call(this, e) || this;
        _this.func = func;
        _this.params = params;
        return _this;
    }
    PAction.prototype.toString = function () {
        return "@" + this.func + this.params;
    };
    return PAction;
}(PUnary));
// CONSTANT
var EMPTY = new PChar('');
var ANY = new PAny();
//const FAIL = new PNot(EMPTY)
// repr
var grouping = function (e, f) {
    return f(e) ? '(' + e.toString() + ')' : e.toString();
};
var inUnary = function (e) {
    return e instanceof POre || e instanceof PSeq || e instanceof PAlt || e instanceof PEdge || e instanceof PFold;
};
// // Grammar
var Grammar = /** @class */ (function () {
    function Grammar(source) {
        this.ns = "" + Grammar.ID++;
        this.names = [];
        this.rules = {};
        this.examples = [];
        if (source !== undefined) {
            load_grammar(this, source);
        }
    }
    Grammar.prototype.set = function (name, e) {
        if (!(name in this.rules)) {
            this.names.push(name);
        }
        this.rules[name] = e;
    };
    Grammar.prototype.get = function (name) {
        return this.rules[name];
    };
    Grammar.prototype.startName = function () {
        if (this.names.length === 0) {
            this.set('EMPTY', EMPTY);
        }
        return this.names[0];
    };
    Grammar.prototype.newRef = function (name, t) {
        return new PRef(this, name);
    };
    Grammar.prototype.generate = function (start) {
        start = start || this.startName();
        return generate(this, { start: start });
    };
    Grammar.prototype.toString = function () {
        var sb = [];
        for (var _i = 0, _a = this.names; _i < _a.length; _i++) {
            var name_1 = _a[_i];
            sb.push(name_1 + " = " + this.rules[name_1]);
        }
        return sb.join('\n');
    };
    Grammar.ID = 0;
    return Grammar;
}());
exports.Grammar = Grammar;
var makelist = function (pe, cnt, es) {
    if (pe instanceof PRef) {
        var u = pe.uname();
        var c = cnt[u] || 0;
        cnt[u] = c + 1;
        if (c == 0) {
            makelist(pe.deref(), cnt, es);
            es.push(pe);
        }
        return es;
    }
    if (pe instanceof PTuple) {
        for (var _i = 0, _a = pe.es; _i < _a.length; _i++) {
            var e = _a[_i];
            makelist(e, cnt, es);
        }
        return es;
    }
    if (pe instanceof PUnary) {
        makelist(pe.e, cnt, es);
    }
    return es;
};
// // ast.env
// def bytestr(b):
// return b.decode('utf-8') if isinstance(b, bytes) else b
var Generator = /** @class */ (function () {
    function Generator() {
        this.peg = null;
        this.generated = {};
        this.generating_nonterminal = '';
        this.sids = {};
    }
    Generator.prototype.getsid = function (name) {
        name = name.toString();
        if (!(name in this.sids)) {
            this.sids[name] = Object.keys(this.sids).length;
        }
        return this.sids[name];
    };
    Generator.prototype.generate = function (peg, options) {
        if (options === void 0) { options = {}; }
        this.peg = peg;
        var name = options.start || peg.startName();
        var start = peg.newRef(name);
        // if 'memos' in option && not isinstance(option['memos'], list):
        var memos = options.memos || peg.names;
        var es = makelist(start, {}, []);
        for (var _i = 0, es_3 = es; _i < es_3.length; _i++) {
            var ref = es_3[_i];
            //assert isinstance(ref, Ref)
            var uname = ref.uname();
            this.generating_nonterminal = uname;
            //console.log(`generating ${uname}`);
            var A = this.emit(ref.deref(), 0);
            //console.log(`generated ${uname}`);
            this.generating_nonterminal = '';
            var idx = memos.indexOf(ref.name);
            // if idx != -1 && ref.peg == peg:
            //     A = this.memoize(idx, len(memos), A)
            this.generated[uname] = A;
        }
        return pasm_1.PAsm.generate(this.generated, start.uname());
    };
    Generator.prototype.emit = function (pe, step) {
        //var pe = inline(pe) FIXME
        var cname = pe.cname();
        if (cname in this) {
            return this[cname](pe, step);
        }
        console.log('@TODO(Generator)', cname, pe);
        return pasm_1.PAsm.pEmpty();
    };
    //     def memoize(self, mp, msize, A):
    //         def match_memo(px):
    //         key = (msize * px.pos) + mp
    // m = px.memo[key % 1789]
    // if m.key == key:
    //     px.pos = m.pos
    // if m.ast != false:
    //     px.ast = m.ast
    // return m.result
    // prev = px.ast
    // m.result = A(px)
    // m.pos = px.pos
    // m.ast = px.ast if prev != px.ast else false
    // m.key = key
    // return m.result
    // return match_memo
    Generator.prototype.PAny = function (pe, step) {
        return pasm_1.PAsm.pAny();
    };
    Generator.prototype.PChar = function (pe, step) {
        return pasm_1.PAsm.pChar(pe.text);
    };
    Generator.prototype.PRange = function (pe, step) {
        return pasm_1.PAsm.pRange(pe.chars, pe.ranges);
    };
    Generator.prototype.PAnd = function (pe, step) {
        var pf = this.emit(pe.e, step);
        return pasm_1.PAsm.pAnd(pf);
    };
    Generator.prototype.PNot = function (pe, step) {
        var pf = this.emit(pe.e, step);
        return pasm_1.PAsm.pNot(pf);
    };
    Generator.prototype.PMany = function (pe, step) {
        var pf = this.emit(pe.e, step);
        return pasm_1.PAsm.pMany(pf);
    };
    Generator.prototype.PMany1 = function (pe, step) {
        var pf = this.emit(pe.e, step);
        return pasm_1.PAsm.pMany1(pf);
    };
    Generator.prototype.POption = function (pe, step) {
        var pf = this.emit(pe.e, step);
        return pasm_1.PAsm.pOption(pf);
    };
    Generator.prototype.PSeq = function (pe, step) {
        var _this = this;
        var pfs = pe.es.map(function (e) { return _this.emit(e, step); });
        return pasm_1.PAsm.pSeq.apply(pasm_1.PAsm, pfs);
    };
    Generator.prototype.POre = function (pe, step) {
        var _this = this;
        var pfs = pe.es.map(function (e) { return _this.emit(e, step); });
        return pasm_1.PAsm.pOre.apply(pasm_1.PAsm, pfs);
    };
    Generator.prototype.PAlt = function (pe, step) {
        return this.POre(pe, step);
    };
    Generator.prototype.PRef = function (pe, step) {
        var uname = pe.uname();
        var generated = this.generated;
        return pasm_1.PAsm.pRef(generated, uname);
    };
    Generator.prototype.PNode = function (pe, step) {
        var pf = this.emit(pe.e, step);
        var tag = pe.tag;
        return pasm_1.PAsm.pNode(pf, pe.tag, pe.shift);
    };
    Generator.prototype.PEdge = function (pe, step) {
        var pf = this.emit(pe.e, step);
        return pasm_1.PAsm.pEdge(pe.edge, pf);
    };
    Generator.prototype.PFold = function (pe, step) {
        var pf = this.emit(pe.e, step);
        var tag = pe.tag;
        var edge = pe.edge;
        return pasm_1.PAsm.pFold(pe.edge, pf, pe.tag, pe.shift);
    };
    Generator.prototype.PAbs = function (pe, step) {
        var pf = this.emit(pe.e, step);
        return pasm_1.PAsm.pAbs(pf);
    };
    Generator.prototype.Skip = function (pe, step) {
        return pasm_1.PAsm.pSkip();
    };
    Generator.prototype.Symbol = function (pe, step) {
        var pf = this.emit(pe.e, step);
        var sid = this.getsid(pe.params[0]);
        return pasm_1.PAsm.pSymbol(pf, sid);
    };
    Generator.prototype.Scope = function (pe, step) {
        var pf = this.emit(pe.e, step);
        return pasm_1.PAsm.pScope(pf);
    };
    Generator.prototype.Exists = function (pe, step) {
        var sid = this.getsid(pe.params[0]);
        return pasm_1.PAsm.pExists(sid);
    };
    Generator.prototype.Match = function (pe, step) {
        var sid = this.getsid(pe.params[0]);
        return pasm_1.PAsm.pMatch(sid);
    };
    return Generator;
}());
var gen = new Generator();
var generate = function (peg, options) {
    if (options === void 0) { options = {}; }
    return gen.generate(peg, options);
};
// ParseTree
var UNKNOWN_URN = '(unknown source)';
var str = function (t) { return t ? t.toString() : ''; };
var TPEGLoader = /** @class */ (function () {
    function TPEGLoader(peg) {
        this.names = {};
        this.peg = peg;
    }
    TPEGLoader.prototype.load = function (t) {
        for (var _i = 0, _a = t.subNodes(); _i < _a.length; _i++) {
            var stmt = _a[_i];
            if (stmt.is('Rule')) {
                var name_2 = stmt.get('name').toString();
                if (name_2 in this.names) {
                    logger('error', stmt.get('name'), "redefined name {name}");
                }
                this.names[name_2] = stmt.get('e');
            }
            else if (stmt.is('Example')) {
                var doc = stmt.get('doc');
                for (var _b = 0, _c = stmt.get('names'); _b < _c.length; _b++) {
                    var name_3 = _c[_b];
                    this.peg.examples.push([name_3, doc]);
                }
            }
            else if (stmt.is('Import')) {
                logger('warning', stmt.get('name'), "ignored import");
            }
            else if (stmt.is('err')) {
                throw new Error('Syntax Error');
            }
        }
        //
        for (var _d = 0, _e = Object.keys(this.names); _d < _e.length; _d++) {
            var name_4 = _e[_d];
            var tt = this.names[name_4];
            this.peg.set(name_4, this.conv(tt));
        }
    };
    TPEGLoader.prototype.conv = function (t) {
        var tag = t.gettag();
        return this[tag](t);
    };
    TPEGLoader.unquote = function (s, pos, sb) {
        if (!s.startsWith('\\', pos)) {
            sb.push(s[pos]);
            return pos + 1;
        }
        if ((s.startsWith('\\x') || s.startsWith('\\X')) && s.length - pos >= 4) {
            var c = Number.parseInt(s.substring(pos + 2, pos + 4), 16);
            sb.push(String.fromCharCode(c));
            return pos + 4;
        }
        if ((s.startsWith('\\u') || s.startsWith('\\U')) && s.length - pos >= 6) {
            var c = Number.parseInt(s.substring(pos + 2, pos + 6), 16);
            sb.push(String.fromCharCode(c));
            return pos + 6;
        }
        if (s.startsWith('\\n')) {
            sb.push('\n');
        }
        else if (s.startsWith('\\t')) {
            sb.push('\t');
        }
        else if (s.startsWith('\\r')) {
            sb.push('\r');
        }
        else if (s.startsWith('\\f')) {
            sb.push('\f');
        }
        else if (s.startsWith('\\v')) {
            sb.push('\v');
        }
        else {
            sb.push(s[pos + 1]);
        }
        return pos + 2;
    };
    TPEGLoader.prototype.Empty = function (t) {
        return EMPTY;
    };
    TPEGLoader.prototype.Any = function (t) {
        return ANY;
    };
    TPEGLoader.prototype.Char = function (t) {
        var s = str(t);
        var sb = [];
        var pos = 0;
        while (pos < s.length) {
            pos = TPEGLoader.unquote(s, pos, sb);
        }
        var text = sb.join('');
        return text.length > 0 ? new PChar(text) : EMPTY;
    };
    TPEGLoader.prototype.Class = function (t) {
        var s = str(t);
        var chars = [];
        var ranges = [];
        var pos = 0;
        while (pos < s.length) {
            pos = TPEGLoader.unquote(s, pos, chars);
            if (s.startsWith("-", pos)) {
                ranges.push(chars.pop());
                pos = TPEGLoader.unquote(s, pos, ranges);
            }
        }
        if (chars.length == 1 && ranges.length == 0) {
            return new PChar(chars.join(''));
        }
        return new PRange(chars.join(''), ranges.join(''));
    };
    // def Ref(self, t):
    // name = str(t)
    // if name in this.peg:
    //     return Action(this.peg.newRef(name), 'NT', (name,), t.getpos4())
    // if name[0].isupper() || name[0].islower() || name.startswith('_'):
    //     logger('warning', t, f'undefined nonterminal {name}')
    // this.peg.add(name, EMPTY)
    // return this.peg.newRef(name)
    // return pChar(name[1: -1]) if name.startswith('"') else char1(name)
    TPEGLoader.prototype.Name = function (t) {
        var name = str(t);
        if (name in this.names) {
            return this.peg.newRef(name, t);
        }
        // if name[0].isupper() || name[0].islower() || name.startswith('_'):
        //     default_logger('warning', t, f'undefined nonterminal {name}')
        // this.peg.add(name, EMPTY)
        // return this.peg.newRef(name)
        // return pChar(name[1: -1]) if name.startswith('"') else char1(name)
    };
    TPEGLoader.prototype.Many = function (t) {
        return new PMany(this.conv(t.e));
    };
    TPEGLoader.prototype.Many1 = function (t) {
        return new PMany1(this.conv(t.e));
    };
    TPEGLoader.prototype.Option = function (t) {
        return new POption(this.conv(t.e));
    };
    TPEGLoader.prototype.And = function (t) {
        return new PAnd(this.conv(t.e));
    };
    TPEGLoader.prototype.Not = function (t) {
        return new PNot(this.conv(t.e));
    };
    TPEGLoader.prototype.Seq = function (t) {
        var _this = this;
        return new (PSeq.bind.apply(PSeq, __spreadArrays([void 0], t.subNodes().map(function (p) { return _this.conv(p); }))))();
    };
    TPEGLoader.prototype.Ore = function (t) {
        var _this = this;
        return POre.new.apply(POre, t.subNodes().map(function (p) { return _this.conv(p); }));
    };
    TPEGLoader.prototype.Alt = function (t) {
        var _this = this;
        return POre.new.apply(POre, t.subNodes().map(function (p) { return _this.conv(p); }));
    };
    TPEGLoader.prototype.Node = function (t) {
        var tag = str(t.tag);
        var e = this.conv(t.e);
        return new PNode(e, tag);
    };
    TPEGLoader.prototype.Edge = function (t) {
        var edge = str(t.edge);
        var e = this.conv(t.e);
        return new PEdge(edge, e);
    };
    TPEGLoader.prototype.Fold = function (t) {
        var edge = str(t.edge);
        var tag = str(t.tag);
        var e = this.conv(t.e);
        return new PFold(edge, e, tag);
    };
    TPEGLoader.prototype.Func = function (t) {
        var _this = this;
        var ts = t.subNodes();
        var funcname = str(ts[0]);
        var es = ts.slice(1).map(function (t) { return _this.conv(t); });
        // if funcname.startswith('choice'):
        //     n = funcname[6:]
        // if n.isdigit():
        //     return TPEGLoader.choiceN(t.urn_, int(n), ps)
        // return TPEGLoader.choice(t.urn_, ps)
        if (funcname === 'abs') {
            return new PAbs(es[0]);
        }
        if (funcname in TPEGLoader.EPSILON) {
            return new PAction(EMPTY, funcname, es, t);
        }
        return new PAction(es[0], funcname, es, t);
    };
    TPEGLoader.EPSILON = {
        'exists': 'exists', 'recover': 'recover',
    };
    return TPEGLoader;
}());
//def grammar_factory():
var logger = function (type, pos, msg) {
    console.log(pos.showing(msg));
};
var TPEGGrammar = tpeg_1.TPEG();
var pegparser = pasm_1.PAsm.generate(TPEGGrammar, 'Start');
var load_grammar = function (peg, source, options) {
    if (options === void 0) { options = {}; }
    var t = pegparser(source);
    var pconv = new TPEGLoader(peg);
    pconv.load(t);
    return peg;
};
// const peg = load_grammar(new Grammar(), `
// A = 'a'
// `)
// console.log(peg);
//# sourceMappingURL=pegtree.js.map