import { PAsm, ParseTree } from './pasm';

const pRule = PAsm.pRule;
const pRef = PAsm.pRef;
const pEmpty = PAsm.pEmpty;
const pChar = PAsm.pChar;
const pRange = PAsm.pRange;
const pAny = PAsm.pAny;
const pAnd = PAsm.pAnd;
const pNot = PAsm.pNot;
const pMany = PAsm.pMany;
const pMany1 = PAsm.pMany1;
const pOption = PAsm.pOption;
const pSeq = PAsm.pSeq;
const pSeq2 = PAsm.pSeq2;
const pSeq3 = PAsm.pSeq3;
const pSeq4 = PAsm.pSeq4;
const pOre = PAsm.pOre;
const pOre2 = PAsm.pOre2;
const pOre3 = PAsm.pOre3;
const pOre4 = PAsm.pOre4;
const pNode = PAsm.pNode;
const pEdge = PAsm.pEdge;
const pFold = PAsm.pFold;
const pDict = PAsm.pDict;

const pAndChar = PAsm.pAndChar;
const pNotChar = PAsm.pNotChar;
const pManyChar = PAsm.pManyChar;
const pOptionChar = PAsm.pOptionChar;
const pMany1Char = PAsm.pMany1Char;

const pAndRange = PAsm.pAndRange;
const pNotRange = PAsm.pNotRange;
const pManyRange = PAsm.pManyRange;
const pOptionRange = PAsm.pOptionRange;
const pMany1Range = PAsm.pMany1Range;

const pDef = PAsm.pDef;
const pIn = PAsm.pIn;


export const CJ = (peg?: any) => {
  if (peg === undefined) {
    peg = {}
  }
  pRule(peg, "ADWARD", pDict("ありとあらゆる いずれにせよ それどころか ちょっとした しかしながら とりあえず こういった どのような どういった 少なくとも できるだけ このように あのように なんらかの おそらくは いずれかの 次いでどう そのような そういった 依然として このような 同じように あのような ああいった したがって そうすると あらかじめ さらなる それでは いかなる これらの あれらの 前もって とりわけ おそらく ちいさな もちろん いったん しばらく もうすぐ たんなる たいした ただちに なおかつ それほど まもなく ぴったり すなわち そうした 時として 順序よく ほとんど どんなに バラバラ たとえば たくさん 主として きわめて こうして だいたい いくらか しばしば もともと 文字通り それらの こういう なかでも ところが いっそう ゆっくり そういう それとも それだけ いっぱい おおきな 引き続き なるべく 何らかの ひとたび 必ずしも まったく めったに もしくは はじめて あらゆる いろんな あるいは ならびに たいてい ちょうど それでも ときどき たまたま あたかも いわゆる ああいう これから もう少し そのまま どういう こうした たいへん なぜなら きっちり ふたたび はっきり どれらの いつでも それから 要するに もっとも 徐々に むしろ そして しかも 後ほど ともに 大した 更なる かりに まるで 小さな とても 丸ごと すでに および こんな 大きな さらに 少しの 初めて 並びに 極めて まさに つまり 自然に 同じく 押して いかに あんな 概して じかに 一般に そんな または もっと それに すると 多くの 同時に わずか 正しく おなじ ほんの たった 二度と かなり 本当に どんな 直ちに 絶えず ずっと 決して あまり ただし もはや しかし 単なる 互いに 求めて よって いつも ついで それで やはり そこで およそ 何にも 別に 必ず すぐ 最も また まず 本来 現在 ほぼ かつ 真に さも ある 常に 十分 正に 時に 特に その 少し もう こう ただ より でも 後で まだ 単に わが ごく なお なぜ あの そう どの 古く 一方 再び 仮に もし 他の 同じ 当の 幸い 次に この やや 順に よく"))
  pRule(peg, "NOUN", pDict("行き当たりばったり あいまい そのため 丸め誤差 おだやか ばらばら いちばん しきい値 そのほか なめらか 見積もり 見せかけ ばらつき それぞれ いつでも ここのつ さまざま 穏やか よっつ 滑らか いくつ それら 改ざん これら 正の数 お勧め その後 はがき その他 明らか いずれ ふたつ しきい 控えめ お薦め ひとつ みっつ 負の数 大まか ばかり どちら お互い すべて 代わり かっこ ななつ かわり あそこ うるう はるか やっつ あれら しくみ 四つ もと 二つ 後ろ 八つ もの 確か 七つ 一つ それ まれ まま 違い ９つ 全て ５つ 長さ たび とき 互い 初め ほか 向き 重み 五つ あれ ７つ そこ ２つ うち あと ３つ ため 深さ １つ どれ 六つ 新た ４つ 高さ いつ 三つ ６つ 何れ どこ ここ これ わけ 九つ ８つ こと ほう"))
  pRule(peg, "BE", pAndRange("でだ", ""))
  pRule(peg, "MOOD1", pRange("まなるたれてず", ""))
  pRule(peg, "TEN", pRange("、，,\n", ""))
  pRule(peg, "EOF", pNot(pAny()))
  pRule(peg, "HIRA", pRange("", "ぁん"))
  pRule(peg, "VerbKA5", pNode(pSeq2(pDict("たどりつ 差し引 取り除 ばらつ 引き続 結び付 気づ 近づ 間引 基づ 気付 色付 空 わ 行 つ 欠 驚 描 続 開 付 置 輝 お 省 巻 覗 招 解 届 聞 除 傾 引 導 働 書 い 動"), pAndRange("い", "かこ")), "VerbKA5", 0))
  pRule(peg, "VerbSA5", pNode(pSeq2(pDict("見つけ出 使い果た もたら 差し戻 浮き出 捜し出 考え出 繰り返 はみ出 なりま やり直 持ち越 指し示 およぼ 費や 待た 脅か 見な 及ぼ なお 活か 見直 見越 取出 みな 果た 伸ば 起こ 吹出 動か ずら なく 繰返 尽く つぶ 延ば 表わ 浮出 だま 減ら 照ら 鳴ら 生か 増や 呼出 満た 落と 合わ 書出 取消 託 許 戻 消 施 記 返 促 探 対 出 騙 通 移 だ 下 離 接 期 属 適 発 合 渡 か 課 介 任 増 残 さ 隠 指 冒 達 表 試 な 放 略 足 直 反 外 押 示 壊"), pAndRange("", "さそ")), "VerbSA5", 0))
  pRule(peg, "VerbTA5", pNode(pSeq2(pDict("役に立 役立 先立 目立 立 経 待 も 分 持 保 勝 打 満"), pAndRange("っ", "たと")), "VerbTA5", 0))
  pRule(peg, "VerbNA5", pNode(pSeq2(pDict("い し 死"), pAndRange("ん", "なの")), "VerbNA5", 0))
  pRule(peg, "VerbMA5", pNode(pSeq2(pDict("しく きざ たた ちな はさ つま ひず くぼ 組込 の 進 含 込 好 こ す 読 済 挟 組 盗 囲 望"), pAndRange("ん", "まも")), "VerbMA5", 0))
  pRule(peg, "VerbRA5", pNode(pSeq2(pDict("あてはま さかのぼ できあが ぶら下が 引っ張 見つか おさま とどま またが つなが まとま かかわ なくな かたま くださ 留ま はま 下が なぞ めく 納ま つま 異な 広が 加わ かぎ 交わ 決ま 起こ 区切 代わ 当た 埋ま 変わ 横切 下回 上が 仕上 分か かか 読取 集ま わか 換わ 高ま 上回 定ま たど 重な 収ま あた 出回 関わ 止ま 始ま 終わ 備わ 替わ 限 劣 偽 作 隣 遡 成 減 入 至 や 戻 切 誤 折 回 頼 知 採 測 彫 振 送 割 お 返 終 取 破 通 移 譲 貼 渡 図 残 困 守 よ 余 絞 な と 陥 き あ 勝 鳴 塗 去"), pAndRange("っ", "らろ")), "VerbRA5", 0))
  pRule(peg, "VerbWA5", pNode(pSeq2(pDict("重なり合 掛け合 振る舞 したが 重ね合 ともな 見合 行な かな 間違 しま 向か かま もら 損な 行 使 伴 問 合 構 覆 揃 そ 整 担 沿 違 失 負 補 扱 言 思 疑 習 い 払 従"), pAndRange("わいうえおっ", "")), "VerbWA5", 0))
  pRule(peg, "VerbGA5", pNode(pSeq2(pDict("相次 また つな 継 防 か"), pAndRange("い", "がご")), "VerbGA5", 0))
  pRule(peg, "VerbBA5", pNode(pSeq2(pDict("及 学 選 並 結 呼"), pAndRange("ん", "ばぼ")), "VerbBA5", 0))
  //OOD !'それ' {'問い合わせ' / '埋め合わせ' / '付け加え' / '突き止め' / '読み取れ' / '当てはめ' / '割り切れ' / '特徴付け' / '読み込め' / '動機付け' / '敷き詰め' / '見せかけ' / '受け取れ' / '関連づけ' / '埋め込め' / '位置付け' / '受け付け' / '閉じこめ' / '繰り下げ' / '置きかえ' / '義務付け' / 'とらわれ' / '言い換え' / '問い合せ' / '受け入れ' / 'とりされ' / '結び付け' / '順序付け' / '入れ替え' / '割り当て' / '関連付け' / '引き受け' / '追いつけ' / '関係付け' / '割りあて' / '押し下げ' / '対応付け' / '置き換え' / '合わせ' / 'つなげ' / '現われ' / 'みなせ' / 'そろえ' / '名付け' / '済ませ' / '繰下げ' / '知らせ' / '分かれ' / '見つけ' / '見つめ' / '仕上げ' / '引替え' / '遅らせ' / '聞こえ' / '割当て' / '切詰め' / '見なせ' / '切換え' / '途切れ' / '置換え' / '浮き出' / 'とどめ' / '満たせ' / 'まとめ' / 'こたえ' / '繰上げ' / 'そなえ' / '切替え' / '近づけ' / '狂わせ' / '見分け' / '受入れ' / 'はずれ' / 'あわせ' / '生まれ' / '問合せ' / 'たため' / '捨て' / '過ぎ' / '下げ' / '感じ' / '避け' / '与え' / '含め' / '決め' / '見せ' / 'なれ' / '換え' / 'うけ' / '論じ' / '防げ' / 'あげ' / '伝え' / 'すぎ' / '調べ' / '乱れ' / '寄せ' / '妨げ' / '加え' / '替え' / '消せ' / '切れ' / '落ち' / '表せ' / '述べ' / '試み' / 'おり' / '扱え' / '探せ' / '分け' / '丸め' / '出せ' / '欠け' / '借り' / '備え' / '曲げ' / '覚え' / '思え' / '収め' / '広げ' / '消え' / '閉じ' / '足り' / '増え' / 'とじ' / '当て' / 'かけ' / '慣れ' / '併せ' / '勧め' / '薄れ' / '言え' / '戻せ' / '隠れ' / '委ね' / '努め' / '使え' / '起き' / '尽き' / '薦め' / '終え' / '挙げ' / '外れ' / '抜け' / '拡げ' / '進め' / '変え' / '占め' / '応じ' / '優れ' / '集め' / '緩め' / '現れ' / '答え' / 'いけ' / '高め' / '並べ' / 'つけ' / '流れ' / '向け' / '取れ' / '免れ' / '設け' / '揃え' / '忘れ' / '離れ' / '壊れ' / '読め' / '助け' / '始め' / '入れ' / '遅れ' / '上げ' / '認め' / '行え' / '伸び' / 'づけ' / '割れ' / '考え' / '比べ' / '渡せ' / '詰め' / '開け' / 'しれ' / '受け' / '持て' / '通じ' / 'ため' / '続け' / '速め' / '付け' / '狭め' / '準じ' / 'でき' / '抑え' / '応え' / '求め' / '合せ' / '整え' / '込め' / 'いえ' / '延び' / '尋ね' / '超え' / '立て' / '空け' / 'ずれ' / '生じ' / '数え' / '越え' / '掛け' / '代え' / '定め' / '捉え' / '返せ' / '綴じ' / '透け' / '埋め' / '触れ' / '用い' / '見え' / '似' / 'い' / 'で' / '割' / '出' / 'み' / '経' / '見' / '得' #Verb1}
  pRule(peg, "Verb1", pSeq2(pNotChar("それ"), pNode(pDict("問い合わせ 埋め合わせ 付け加え 突き止め 読み取れ 当てはめ 割り切れ 特徴付け 読み込め 動機付け 敷き詰め 見せかけ 受け取れ 関連づけ 埋め込め 位置付け 受け付け 閉じこめ 繰り下げ 置きかえ 義務付け とらわれ 言い換え 問い合せ 受け入れ とりされ 結び付け 順序付け 入れ替え 割り当て 関連付け 引き受け 追いつけ 関係付け 割りあて 押し下げ 対応付け 置き換え 合わせ つなげ 現われ みなせ そろえ 名付け 済ませ 繰下げ 知らせ 分かれ 見つけ 見つめ 仕上げ 引替え 遅らせ 聞こえ 割当て 切詰め 見なせ 切換え 途切れ 置換え 浮き出 とどめ 満たせ まとめ こたえ 繰上げ そなえ 切替え 近づけ 狂わせ 見分け 受入れ はずれ あわせ 生まれ 問合せ たため 捨て 過ぎ 下げ 感じ 避け 与え 含め 決め 見せ なれ 換え うけ 論じ 防げ あげ 伝え すぎ 調べ 乱れ 寄せ 妨げ 加え 替え 消せ 切れ 落ち 表せ 述べ 試み おり 扱え 探せ 分け 丸め 出せ 欠け 借り 備え 曲げ 覚え 思え 収め 広げ 消え 閉じ 足り 増え とじ 当て かけ 慣れ 併せ 勧め 薄れ 言え 戻せ 隠れ 委ね 努め 使え 起き 尽き 薦め 終え 挙げ 外れ 抜け 拡げ 進め 変え 占め 応じ 優れ 集め 緩め 現れ 答え いけ 高め 並べ つけ 流れ 向け 取れ 免れ 設け 揃え 忘れ 離れ 壊れ 読め 助け 始め 入れ 遅れ 上げ 認め 行え 伸び づけ 割れ 考え 比べ 渡せ 詰め 開け しれ 受け 持て 通じ ため 続け 速め 付け 狭め 準じ でき 抑え 応え 求め 合せ 整え 込め いえ 延び 尋ね 超え 立て 空け ずれ 生じ 数え 越え 掛け 代え 定め 捉え 返せ 綴じ 透け 埋め 触れ 用い 見え 似 い で 割 出 み 経 見 得"), "Verb1", 0)))
  pRule(peg, "Despite", pNode(pOre2(pSeq2(pDict("かか 関"), pChar("わらず")), pChar("関係なく")), "Despite", 0))
  pRule(peg, "UnitPrefix", pOre4(pNode(pDict("約 およそ"), "Aprox", 0), pNode(pDict("もう さらに 更に"), "More", 0), pNode(pDict("高々 たかだか 多くとも 最大"), "AtMost", 0), pNode(pDict("少なくとも 最小"), "AtLeast", 0)))
  //OOD [.(){}, +\-*/%\\A-Za-z0-9] {/*-1*/[.(){}, +\-*/%\\A-Za-z0-9]* #Code}
  pRule(peg, "Code", pSeq2(pRange(".(){}, +-*/%\\", "AZaz09"), pNode(pManyRange(".(){}, +-*/%\\", "AZaz09"), "Code", -1)))
  pRule(peg, "NumericNoun", pNode(pOre2(pChar("複数"), pRange("一二三毎数先今次", "")), "Noun", 0))
  pRule(peg, "NONUNIT", pDict("分野 日本 種類"))
  pRule(peg, "KATA", pRange("ー・", "ァヶ"))
  //OOD '以上' {/*-2*/'' #Gte}
  //OOD '以下' {/*-2*/'' #Lte}
  //OOD '未満' {/*-2*/'' #Lt}
  pRule(peg, "UnitPostfix", pOre(pNode(pDict("程 ほど"), "Aprox", 0), pNode(pDict("ごと 毎"), "Each", 0), pSeq2(pChar("以上"), pNode(pEmpty(), "Gte", -2)), pSeq2(pChar("以下"), pNode(pEmpty(), "Lte", -2)), pSeq2(pChar("未満"), pNode(pEmpty(), "Lt", -2))))
  pRule(peg, "XVERB", pDict("くりかえし 行きあたり くりかえせ らっしゃり おこない みあわし あつかい くり上げ つくばい ふんぞり きあわせ めあわせ しずまり あつまり くりかえ うそぶき みまわし はからえ ささやき いつぶし かさなり みくだし みあわせ ながらえ とどまり かかわり いあわせ めあわし まつわり ころがり めぐらし 引っ込み じゅんじ わずらい みおとし よろこび かんがえ くたびれ ほろぼし きかかり さいなみ めぐらせ かぶさり くつろぎ つらぬき かたづけ ころばし たまわり しょうじ つくろい はからい みなおし しゃくり はたらき あしらい しあがり うつむき 行き届き ならわし ふさがり そこない みやぶり はだかり のたうち きあわし くりだせ くりだし みなおせ 行き当り しゃぶり くるめき くりあげ あらわし かたまり きはじめ ふるまい みちびき みがき いそぎ たがい 減らし はずみ まつり ころげ もうけ しのべ つくり わかれ 遊ばせ みたて 過ごせ はらい そろい ぬぐい みきり にごり かえり つづり しんじ ならせ ひたし うつり 習わし なおし しょい かえれ はじめ ふるえ こもれ たくり ならび ねつけ 荒らし たらし 降ろし ちがえ いっし しまり いびり はなれ ひろげ 合わし もたせ さばけ そんじ しげり まかせ すかし わたし おしみ くぐり かいし つかみ こもり ひずみ あがれ おこせ あかし くらせ つかい たもち しぼり ふくみ とどけ こぼれ 霜枯れ うかび まかし ころせ かぶせ たおせ 曲がり 波打ち つつみ 転がり ほどき くされ のぞみ のぼり うまれ ほぐし こなし 覚まし みなし かじり くわし うたい とおり くるい きざみ そだて みとり なまけ ゆずり あばれ 塞がり せまり 踏まえ はたし いため やぶり しとめ つるし ころし かさね くねり たまり たおし かもし よがり おじけ のがし さらし うかれ そやし むせび おとせ なさり ふるい なじみ かわし とらえ くどき たぎり あわし 尽くし まがり かわり ついて よろい つかり 突き出 かざり そびれ いつき はこべ はずせ 延ばし かぞえ すがり わめき にらみ ふぶき 寝かし えがき 冷まし きずき ゆわえ 仕立て おとし ふらし のばせ つのり のこれ 見つけ 混じり しのぎ ねむり くずれ はいり くらし 手向け あらし みつけ いぶり 押さえ 住まい とばし しゃれ あそび ちがい くらみ 起こり まなび いこみ すわり 行届き つづけ 滅ぼし にじみ 付合い 枯らし 沸かし おろせ みこし かがみ つがい しかめ やぶれ もたれ がかり すすり とがめ ころび みとれ とどき 当たり おびき ゆるぎ 積もり しかけ いなし すごし ながし はずれ あたえ 鳴らし なおり あやめ すくい ぬかり すまし どなり むすび のこし いわい たすけ 果たし わたせ ひねり からし あつめ かかれ かくし いさみ こおり しとり かわせ どおり めぐり 仕切り 吸付け わたり およぎ はなち なげき わらい 窄まり つもり そぼち めかし 上がれ ちぎり からげ とまり 背負い 終わり あゆみ 上がり 伸ばし ふくめ せしめ かかえ 名乗り しずみ まがい 下がり はずし くくり のぼせ つぶせ ほうり かくれ すぐり にぎり そそり もとめ みだせ あまり ねらい みのり 落とせ つぶし くらい ねだり あわせ のこり からみ たため ほうじ しこめ だまり よこし ちぎれ あたり しめし そろえ 善がり みだし はこび あさり たたき いがみ あぐみ しぶり もうし 引張り はしり ふくれ とおせ にあい わかり あきれ わかし 止まり もらい ながせ おとり はさみ くだし かぶり 見舞い すべり よどみ かわれ かかり いかけ かなえ つぶれ 詰まり はなせ 向かい からめ 飛ばし しつけ くずせ ねかし ちらし しらべ 先立ち みあい 見知り 飛ばせ まとめ くだき まわり のばし ふけり こたえ みこみ 気づき 透かし あるけ あいし ただし こすり くだけ とぼけ 澄まし くるみ やかし なぐり のぼれ あおみ 散らし 寝入り もらし はまり たどり したて ひらき しだき さわぎ もどし 晴らし しいれ のめり かんじ ながれ ひびき ひかり 腫らし まわし こまり のめし 交わし しっけ かざし まとい 掛かり 知らせ 騒がせ みかけ すさび かずき 広がり こなせ まよい 損ない のがれ うばい 漏らし 加わり 重なり このみ 口説き はやり けむり 替わり つまり きつけ さけび とおし やどり きばり つめり くわえ みだれ しこみ しだし 区切り こがれ 起こし おろし とちり 食らい みきれ 泊まり にがし まどい さがし しおれ くずし ふうじ おくり もどせ くもり すくみ けずり くるめ はらえ 浮かび 交じり おくれ むしり つづき もぐり しばり すごせ みこめ うつし いやし はやし くばり はらし とばせ にんじ 変わり しわけ かくせ さんじ 合わせ たけり おこし すくめ おがみ ねがい しょげ くさり 決まり ふさぎ しおり おさえ 締まり 分かれ 食わせ まかり はじき かえし いたし みわけ 明かし かよい さぐり 憎まれ しあげ ただせ 馴染み たずね つくし みあげ 書入れ 掘出し 繰返し とぎれ ささげ ほこり さばき 仕舞い まもり たがえ ふくし おもい 起こせ みぬき なすり こぼし くぼみ まみれ みいり 静まり たのみ おこり 見取り たがり たたみ だまし きらい いじり すすみ 見掛け すすぎ さがり にじり かたり こぎり 怒鳴り えらび そなえ ひろい むかい おどし まねき 浮かれ もどり きづき 刺さり なやみ あぶり まくれ 差し出 おおせ せんじ むかえ 溜まり まじり もつれ さわり つかし 隔たり かすめ たくし なおせ けだし まくり まぎれ なまり つかれ はかり および ゆめみ あがり きわめ あらい あるき 固まり ぬすみ 計らい のぞき まるめ つなぎ しらせ 代わり つかえ ころべ ほうけ いかり しきり まわせ かつぎ ひろめ きそえ 過ごし かえせ 落とし 計らえ 片付け 惜しみ かまえ そそぎ 換わり きこみ こわし しのび 振分け つたえ ねばり ほおけ くらべ 向かえ 焦がれ すすめ たたり 飛び出 はなし 暮らし せおい みなれ ならし 気付き さそい わすれ そびえ つつき つまみ おうじ おどり 下ろし 生まれ まわれ かぶれ いなみ 組み立 からび 間違い 帰り 釣り せき せり 尖り 育ち 掻き ぼけ 溶け 生み ない 篭り 刈り 構い 冴え けし 執り 誑し 探り 説き 見せ なれ 括り 掃き 語り 散り 推し 回れ 貯め 映え ぬい 宿り しい 返り 痩せ 怒り 寄せ 選り きけ ぶち のび 暮し 焦げ ぬり ぶし 倒せ 負え 咎め いれ 駆け 窶れ 曲げ 届け 着き 渡し 挿し 住み 扱い 死に 縮み 限り 醒め 転げ 恋い こき 鳴り もめ 慣れ 動き 均し 降し まね 撚り 叱り 裂け 合し 砕け 切り のみ 封じ 抜け 裂き 痛み そみ 失せ ぬぎ どり 違え だれ すい たり 酌み 薙ぎ 負い 競べ はげ 濡れ 現し 呼び 続き むけ もち 馴れ 壊れ まぜ 助け 尽し 縛り 舞い よび 植え よし 直し 嵌め 上げ 黙り 伸び へり 追い 延し 従い 沈み 有り ふて 待ち 捌き ぶり もえ 萌え 付け 聴き 巻き 苛み 泊り 造り 空き 零れ ふい 告げ 減り 効き ふれ 曲り 持ち ほり 腫れ 呆れ 纏い 上り 殺ぎ 射し 読み もて 過ぎ 伏せ 感じ 売り もみ やめ そげ 染め さし 詰り 呑み 込み 捕り 破り 換え 劣り 会い 創り 済し 祝い 竦め てり 取り むし 反り さえ 足し 煉り 甘え 忌み 絡み 漬け 丸め 搾り 漏れ 吠え 移り 組み 招き 暮れ 漁り 繕い 残り 漉し 白み めし 叩き 変り いい はめ 余り 撃ち 澄み 次ぎ はけ おし 照れ 思い たえ 炙り 来し とめ かち かて きえ 砕き 記し こり より のけ あけ よみ 代り 勇み なり 漉き 合え 寄り 隔て 曇り 揺ぎ 接ぎ 練り しり だし 浮き 分り まち 設け はて 競り 揃え 下り 交い 作り 催し 削り とき 始め 眠り ませ やみ 酔い わり 除け 被せ 攻め むき わき 浚え あり 剥け 勝ち 叫び かし ばけ そい 好み いり 届き 延び にえ だせ 奪い 満ち 存じ 潰れ 嬲り ふけ 返せ 着せ 崩れ のめ 責め こね 凍り 延べ 頼み 洒落 描き 紛れ 決め かね ぬき 懸り まけ そぎ 当り かみ もり 初め 撫で 廻し 蒔き すめ 抜き 走り 儲け おり 崩し ひえ 副え 肥り 分け 供え 飽き 塗れ 磨り 学び 果て 振り 後れ 備え そめ 縋り 通り 広げ とえ すえ ふり やき 出来 勝て ごて 捲り 賜り 浸し 戻せ 捜し 汚し 注ぎ 送り 映し 締め 並び 攣れ 足せ 迎え 恵み 起き 争い 食べ 放り 拭き 解き 折れ しけ うせ 葺き 止め 指し 揉み ほれ さき ゆき 保ち 掛り 落し 轢き 窄み 向き 繋ぎ はり 稼ぎ 会え 栄え 着け 戯れ づき 食い しれ 膨れ 構え 蒸し 飾り ため 揚げ 汲み きれ 放れ 成し たち 騙し かめ まげ 頻り 割り 合せ かえ 殺せ 活け 尋ね つめ ずれ 引き 通し 浴び 燃え 祭り 想い 毀れ 募り 捨て たげ こめ のり ぐれ 急き 止り おえ 恨み 包み くえ たせ 履き 迫り 決り ひし 障り のし 消し すぎ 貼り じみ あい 伸し 示し くみ 混じ 吐き 縫い ざし 覆い 覚え 生き 運べ 張れ ひめ 醸し 湧き 照り 極め 増し 担い 果し 損じ 駆り 吸い ゆり 成り 喜び 登り おれ 仕え どけ 解け 払い 残し 抱き 尽き よい 挟み 冷え 合い 浸り つぎ 奮い あせ めき 鎮め 集め 置き 嫌い 留め いけ みち 並べ しみ 預け 昇り 跳ね 仰せ かせ おび 外し 違い 仕掛 廻り 入り 飼い 勝り 咲き 入れ あき だけ 逃げ 写し 改め わび 比べ 送れ ざれ 乾し よれ 伝い 塞ぎ うて はえ のべ 続け やせ 直せ 病み 交し 判じ 継げ 曝し られ 好き 立て しに 数え 刻み 隣り 添え 掴み 齧り 定め 拝み かび 震い 埋め ぶれ 触れ 磨き 生け 離し 結え いき 焼け 剃り 信じ 使い 歌い 太り 鳴き すみ たれ 話し 利き つみ 粘り 選び 競い なえ 剥き それ 伝え 篭め 行い こし 貫き 活き 擂り 調べ えみ 乱れ ひね 消せ 切れ 移し 生え 脱ぎ 踏み とび 狩り 騒ぎ 歩き 押え 出せ 去り 錆び 睨み 配り 突き こけ 消え 結い まい 泳ぎ 探し 渡り かけ 捲き にせ 毀し あて 食み 脹れ こせ 輝き まき 繰り 煩い 細り きせ やれ だき 翳し よめ 捏ね 占め 倒れ つれ 生れ 刷り 直り やり 困り 採り みれ 言い 隠せ 聞き 向け 朽ち おじ 便り 疲れ 炒り 伏し たけ 慣し 堪え あみ 寄れ 弾き 踊り 固め 量り きめ づけ 摺り 慰み 光り 張り 休み 滑り はぎ 透り 断ち 荒し よえ 求め 教え ぼり ひき 雇い かげ 表し 洗い 彫り 通せ 潰し 請け やけ 震え 纏め 伸べ 望み 拵え はき 見え 申し はれ のき 至り 係り こぎ 遣り 在り 悩み 遣い 下げ みせ 贈り 復し 惚け 炊き 迷い 狙い 絞り 折り てき 放ち 拾い 撒き ちび 誤り 揺り 越せ はみ 誇り 痴れ 搗き 産み 懲り 歩け 問い 絞め おい しめ つき そえ 掘り 打て 含み はじ 欠け 借り 打ち 兼ね 啜り 廃れ すき ふせ 当て 救い 潜り 涼み 鋤き こび 貸し 揉め 隠れ せめ 閉め ふし くい 拭い 耐え たき 添い 笑い 挙げ 討ち 外れ 乗り 枯れ 紛い けり 痛め 納め 褒め 別れ 挽き 吊し 噴き のれ 抱え どき 据え ずり けせ 統べ 荒れ 腐れ 恥じ 斬り 飛び 怨み 遅れ 狂い よじ 転び 連ね うり 盗み 支え とれ 詰め おち 殴り 老い 受け 握り おけ なめ 任せ 遂げ ぬれ 立ち 負け 摘み なし 嵌り とげ 導き 座り 編み もれ こい 顰め すね はね 堪り 煎じ 晒し 遊び よせ 越え 開き 済み うき すげ 投げ ばり 絶え 上せ ふみ こげ 通い 担ぎ なき 思し 止み 恐れ うみ 育て 参り 充て 提げ 生り 老け 勤め 溜り ゆで 与え 含め 盛り 重ね たし ねぎ すけ いみ 巡り くめ 回し 召し 譲り にげ 返し 及び 回せ ひり 熬り つり 惚れ 建て 坐り 被り 替え 落ち あび われ 流し 清め 這い 浚い 弾み 退け 引け ぬけ 擦り 飲み 習い さけ 沸き 棄て 凌ぎ 泣き ふき 閉じ しし 綴り 乞い とじ 計り 溶き ばれ 差し なで 馴し いて 煮え 明け さめ 隠し きき ちり 忍び 倒し とけ 進め まえ 焼き 溺れ 答え 殺し 怖じ 占い 囲み 降り ほめ 誘い 取れ 誉め 嗅ぎ こみ こえ 忘れ かぎ 試し 守り 覚し 辷り くち 乱し 和え 罷り 考え 揃い もぎ 開け 塗り 持て 吊り じれ 染み 逃れ いに 刺し 混ぜ きり 化け 放し 威し 起し 笑み 働き 放せ 売れ 書き 捌け 綴じ 浮び なぎ とぎ 欠き 惑い 織り 出し 跳び 煎り 付き 撲り 除き 退き あえ かれ 囲い 馳せ そり 回り 祓い 下し うけ あげ 湿り いせ 凝り 嘆き とり 怠け 商い 加え 継ぎ 戻し 表せ うめ なげ 暴れ 渋り 舐り 擦れ えり 吹き すて 逢い 茂り 許し 詣で 崩せ へし 組め 漕ぎ 脅し 茹で 足り 撥ね 結び 逃し 達し みえ 塞き 垂れ 運び 干し 過し 詠み つげ 越し 控え 残れ 心得 わけ 離せ 中り 払え 誘き 侘び 薦め 積み 向い 逸れ 播き 破れ 裁ち 躍り はせ がり かき 竦み 穿き 休め 焙じ 触り 流れ 焚き つけ かい むせ 捻り おせ 知り 離れ まし あめ 咳き 壊し 詫び 割れ 撮り うれ 押し 響き 渡せ 敷き ほし 研ぎ 扱き 替り さび うち 愛し 戻り うえ 貰い 噛み 刳り 抑え 応え 急ぎ かり もし ねり 交ぜ 込め 透き 晴れ さり 願い じし 歩み むれ 曳き 覚め くれ 掛け 畳み たて 進み 連れ 明き さげ 流せ おき 買い 祈ぎ 懸け 溜め"))
  pRule(peg, "ADJ_CHECK", pOre4(pChar("そう"), pChar("過ぎ"), pChar("すぎ"), pRange("さかくけい", "")))
  pRule(peg, "NewNoun", pIn("\'定義語\'"))
  pRule(peg, "DEFNOUN", pMany1(pSeq2(pNotChar("」"), pAny())))
  pRule(peg, "xTen", pFold("", pOptionRange("、，,\n", ""), "Ten", 0))
  pRule(peg, "Unit", pNode(pOre(pChar("四半期"), pChar("とおり"), pChar("進数"), pChar("度目"), pChar("通り"), pChar("か月"), pChar("番目"), pChar("日間"), pChar("か所"), pChar("等分"), pRange("種個名色倍層列例辺度部面台位進割乗年組週秒元％月版回内%型重時項日分桁章つ行番", ""), pMany1Range("ー・", "ァヶ")), "Unit", 0))
  pRule(peg, "VerbalNoun", pNode(pSeq2(pRef(peg, "XVERB"), pRef(peg, "XVERB")), "VNoun", 0))
  pRule(peg, "DictNoun", pNode(pRef(peg, "NOUN"), "Noun", 0))
  pRule(peg, "Adjective", pNode(pSeq2(pDict("残り少な きめ細か 規則正し は文字 すばや 好まし 興味深 注意深 望まし 乏し 正し 小さ 詳し 等し にく 数多 うま 著し 細か 四角 やす 厳し 難し 危う 幅広 少な 大き 黄色 同じ 美し 新し 明る なる 細 広 速 暗 薄 重 全 短 低 軽 濃 青 古 遠 近 遅 丸 太 多 赤 長 悪 若 よ 高 弱 粗 賢 強 な 疎 早 良 狭 黒 深 厚"), pAnd(pRef(peg, "ADJ_CHECK"))), "Adjective", 0))
  pRule(peg, "DefNoun", pOre4(pSeq3(pChar("「"), pNode(pDef("\'定義語\'", pRef(peg, "DEFNOUN")), "Phrase", 0), pChar("」")), pSeq3(pChar("『"), pNode(pMany(pSeq2(pNotChar("』"), pAny())), "Phrase", 0), pChar("』")), pSeq3(pChar("【"), pNode(pMany(pSeq2(pNotChar("】"), pAny())), "Phrase", 0), pChar("】")), pSeq3(pChar("〔"), pNode(pMany(pSeq2(pNotChar("〕"), pAny())), "Phrase", 0), pChar("〕"))))
  pRule(peg, "NONHIRA", pSeq3(pNotRange("", "ぁん"), pNotRange("、，,\n", ""), pAny()))
  //OOD [、，,\n] {/*-1*/'' #Ten}
  pRule(peg, "Ten", pSeq2(pRange("、，,\n", ""), pNode(pEmpty(), "Ten", -1)))
  //OOD HIRA {/*-1*/HIRA* #err}
  pRule(peg, "Error", pSeq2(pRange("", "ぁん"), pNode(pManyRange("", "ぁん"), "err", -1)))
  pRule(peg, "EOS", pSeq2(pOptionRange("。．.\n", ""), pRef(peg, "EOF")))
  //OOD 'り' ^ {/*-1*/{/*-1*/'' #} #AndThen}
  pRule(peg, "xPast", pOre3(pSeq2(pChar("り"), pFold("", pNode(pEmpty(), "", -1), "AndThen", -1)), pFold("", pNode(pSeq3(pOptionChar("な"), pChar("ら"), pOptionChar("ば")), "", 0), "If", 0), pRef(peg, "xBase")))
  pRule(peg, "xVerbU", pOption(pRef(peg, "xBase")))
  //OOD 'う' ^ {/*-1*/xBase? #Will}
  pRule(peg, "xVerbO", pSeq2(pChar("う"), pFold("", pOption(pRef(peg, "xBase")), "Will", -1)))
  //OOD 'あ' {/*-1*/xMoodA #Exist}
  pRule(peg, "Exist", pSeq2(pChar("あ"), pNode(pRef(peg, "xMoodA"), "Exist", -1)))
  pRule(peg, "xShould", pSeq2(pFold("", pDict("べき べし はず"), "Should", 0), pOption(pRef(peg, "xNoun"))))
  //OOD 'ば' ^ {/*-1*/'' #If}
  pRule(peg, "xVerbE", pOre2(pSeq2(pChar("ば"), pFold("", pEmpty(), "If", -1)), pSeq2(pFold("", pEmpty(), "AbleTo", 0), pRef(peg, "xVerb1"))))
  //OOD 'あ' ^ {/*-1*/xMoodA #Exist}
  pRule(peg, "xExist", pSeq2(pChar("あ"), pFold("", pRef(peg, "xMoodA"), "Exist", -1)))
  //OOD 'かも' [知し] 'れ' ^ {/*-11*/'ない' / 'ません' / xMood #May}
  pRule(peg, "xMay", pSeq2(pSeq3(pChar("かも"), pRange("知し", ""), pChar("れ")), pFold("", pOre3(pChar("ない"), pChar("ません"), pRef(peg, "xMood")), "May", -11)))
  //OOD 'よう' ^ {/*-2*/'' #Like}
  pRule(peg, "xLike", pSeq2(pSeq2(pChar("よう"), pFold("", pEmpty(), "Like", -2)), pOption(pRef(peg, "xNoun"))))
  pRule(peg, "By", pNode(pOre3(pChar("よる"), pSeq2(pChar("よっ"), pOption(pOre2(pSeq2(pChar("て"), pOption(pRef(peg, "xNounOf"))), pChar("た")))), pChar("より")), "About", 0))
  pRule(peg, "xNoun", pSeq3(pNot(pRef(peg, "NOUN")), pNot(pRef(peg, "ADWARD")), pRef(peg, "xNoun2")))
  pRule(peg, "Adword", pSeq2(pNode(pOre2(pRef(peg, "ADWARD"), pChar("が")), "Ad", 0), pOption(pRef(peg, "xNoun"))))
  pRule(peg, "Measure", pSeq2(pNode(pSeq(pOption(pRef(peg, "UnitPrefix")), pOre2(pRef(peg, "Code"), pRef(peg, "NumericNoun")), pNot(pRef(peg, "NONUNIT")), pRef(peg, "Unit"), pOption(pRef(peg, "UnitPostfix"))), "Measure", 0), pOption(pRef(peg, "xNoun"))))
  pRule(peg, "NounChunk0", pOre2(pSeq2(pRef(peg, "VerbalNoun"), pOre3(pRef(peg, "xNoun"), pRange("、，,\n", ""), pRef(peg, "EOF"))), pSeq2(pRef(peg, "DictNoun"), pOption(pRef(peg, "xNoun")))))
  pRule(peg, "AdjectiveChunk", pSeq2(pRef(peg, "Adjective"), pRef(peg, "xAdjective")))
  pRule(peg, "XVERB2", pOre2(pSeq2(pRef(peg, "XVERB"), pNotRange("たてまな", "")), pSeq2(pRef(peg, "NONHIRA"), pRef(peg, "XVERB2"))))
  pRule(peg, "PatNoun", pNode(pOre2(pSeq2(pRef(peg, "XVERB"), pMany1(pRef(peg, "NONHIRA"))), pSeq2(pRef(peg, "NONHIRA"), pOption(pOre2(pRef(peg, "XVERB2"), pMany1(pRef(peg, "NONHIRA")))))), "PNoun", 0))
  pRule(peg, "Sentence", pNode(pSeq2(pMany(pOre3(pRef(peg, "Chunk"), pRef(peg, "Ten"), pRef(peg, "Error"))), pRef(peg, "EOS")), "Sentence", 0))
  //OOD 'の' ^ {/*-1*/{/*-1*/'' #} #ThingThat}
  //OOD 'の' ^ {/*-1*/{/*-1*/'' #} !'み' #Of}
  pRule(peg, "xNounOf", pOre3(pFold("", pNode(pOre2(pChar("こそ"), pRange("はがも", "")), "", 0), "Subject", 0), pSeq3(pSeq2(pChar("の"), pFold("", pNode(pEmpty(), "", -1), "ThingThat", -1)), pNot(pRef(peg, "NOUN")), pRef(peg, "xNoun")), pSeq2(pSeq2(pChar("の"), pFold("", pSeq2(pNode(pEmpty(), "", -1), pNotChar("み")), "Of", -1)), pOption(pRef(peg, "xLike")))))
  pRule(peg, "Against", pNode(pOre2(pChar("対する"), pSeq2(pChar("対し"), pOption(pOre2(pSeq2(pChar("て"), pOption(pRef(peg, "xNounOf"))), pSeq2(pChar("た"), pOption(pRef(peg, "xPast"))))))), "Against", 0))
  pRule(peg, "About", pNode(pOre2(pSeq2(pChar("ついて"), pOption(pRef(peg, "xNounOf"))), pSeq2(pChar("関し"), pOption(pOre2(pSeq2(pChar("て"), pOption(pRef(peg, "xNounOf"))), pSeq2(pChar("た"), pOption(pRef(peg, "xPast"))))))), "About", 0))
  //OOD 'ません' ^ {/*-3*/{/*-3*/'でした'? #} #Not}
  //OOD 'ましたら' ^ {/*-4*/{/*-4*/'' #} #If}
  //OOD 'ました' ^ {/*-3*/{/*-3*/'' #} #Past}
  //OOD 'ましても' ^ {/*-4*/{/*-4*/'' #} #EvenIf}
  //OOD 'まして' ^ {/*-3*/{/*-3*/'' #} #And}
  pRule(peg, "xPolite", pOre(pSeq2(pFold("", pNode(pDict("ます ましょう"), "", 0), "Base", 0), pOption(pRef(peg, "xBase"))), pSeq2(pSeq2(pChar("ません"), pFold("", pNode(pOptionChar("でした"), "", -3), "Not", -3)), pOption(pRef(peg, "xBase"))), pSeq2(pChar("ましたら"), pFold("", pNode(pEmpty(), "", -4), "If", -4)), pSeq2(pSeq2(pChar("ました"), pFold("", pNode(pEmpty(), "", -3), "Past", -3)), pOption(pRef(peg, "xPast"))), pSeq2(pChar("ましても"), pFold("", pNode(pEmpty(), "", -4), "EvenIf", -4)), pSeq2(pChar("まして"), pFold("", pNode(pEmpty(), "", -3), "And", -3))))
  //OOD 'だ' ^ {/*-1*/{/*-1*/'' #} #Past}
  //OOD 'でから' ^ {/*-3*/{/*-3*/'' #} #After}
  //OOD 'でも' ^ {/*-2*/{/*-2*/'' #} #EvenIf}
  //OOD 'で' ^ {/*-1*/{/*-1*/'' #} #And}
  pRule(peg, "xVerbIXD", pOre4(pSeq2(pSeq2(pChar("だ"), pFold("", pNode(pEmpty(), "", -1), "Past", -1)), pOption(pRef(peg, "xPast"))), pSeq2(pChar("でから"), pFold("", pNode(pEmpty(), "", -3), "After", -3)), pSeq2(pChar("でも"), pFold("", pNode(pEmpty(), "", -2), "EvenIf", -2)), pSeq2(pSeq2(pChar("で"), pFold("", pNode(pEmpty(), "", -1), "And", -1)), pOption(pRef(peg, "xTry")))))
  //OOD 'らし' ^ {/*-2*/'' #Sound}
  //OOD 'のなら' ^ {/*-3*/{/*-3*/'ば'? #} #If}
  //OOD 'と' ^ {/*-1*/{/*-1*/'か'? #} #That}
  //OOD 'まで' ^ {/*-2*/{/*-2*/'' #} #Until}
  //OOD 'など' ^ {/*-2*/{/*-2*/'' #} #SuchThat}
  //OOD 'ほど' ^ {/*-2*/{/*-2*/'' #} #Case}
  //OOD 'まま' ^ {/*-2*/{/*-2*/'' #} #AsIs}
  //OOD 'には' ^ {/*-2*/{/*-2*/'' #} #That}
  //OOD 'の' ^ {/*-1*/{/*-1*/'' #} #That}
  pRule(peg, "xBase", pOre(pRef(peg, "xMay"), pRef(peg, "xShould"), pSeq2(pSeq2(pChar("らし"), pFold("", pEmpty(), "Sound", -2)), pRef(peg, "xAdj")), pSeq2(pFold("", pNode(pDict("のみ だけ"), "", 0), "OnlyThat", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pFold("", pNode(pDict("ため 為"), "", 0), "Because", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pFold("", pNode(pDict("たび ごと"), "", 0), "Whenever", 0), pOption(pRef(peg, "xNoun"))), pFold("", pNode(pDict("ので から"), "", 0), "Because", 0), pSeq2(pFold("", pNode(pDict("かぎり 限り"), "", 0), "AsLong", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pFold("", pNode(pSeq3(pOptionChar("の"), pChar("か"), pOption(pDict("どうか 否か"))), "", 0), "Whether", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pFold("", pNode(pOre(pChar("とき"), pSeq2(pChar("と"), pRange("、，,\n", "")), pChar("時"), pChar("場合"), pChar("際"), pChar("ところ")), "", 0), "If", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pChar("のなら"), pFold("", pNode(pOptionChar("ば"), "", -3), "If", -3)), pSeq2(pFold("", pNode(pDict("とおり よう"), "", 0), "As", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("と"), pFold("", pNode(pOptionChar("か"), "", -1), "That", -1)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("まで"), pFold("", pNode(pEmpty(), "", -2), "Until", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("など"), pFold("", pNode(pEmpty(), "", -2), "SuchThat", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("ほど"), pFold("", pNode(pEmpty(), "", -2), "Case", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("まま"), pFold("", pNode(pEmpty(), "", -2), "AsIs", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pChar("には"), pFold("", pNode(pEmpty(), "", -2), "That", -2)), pSeq2(pSeq2(pChar("の"), pFold("", pNode(pEmpty(), "", -1), "That", -1)), pOption(pRef(peg, "xNoun")))))
  //OOD 'る' ^ {/*-1*/'' #Base}
  //OOD 'った' ^ {/*-2*/'' #Past}
  //OOD 'れば' ^ {/*-2*/'' #If}
  //OOD 'ってから' ^ {/*-4*/'' #After}
  //OOD 'っても' ^ {/*-3*/'' #EvenIf}
  //OOD 'って' ^ {/*-2*/'' #And}
  pRule(peg, "xMoodA", pOre(pSeq3(pChar("り"), pAndChar("ま"), pRef(peg, "xPolite")), pSeq2(pSeq2(pChar("る"), pFold("", pEmpty(), "Base", -1)), pOption(pRef(peg, "xBase"))), pSeq2(pSeq2(pChar("った"), pFold("", pEmpty(), "Past", -2)), pOption(pRef(peg, "xPast"))), pSeq2(pChar("れば"), pFold("", pEmpty(), "If", -2)), pSeq2(pChar("ってから"), pFold("", pEmpty(), "After", -4)), pSeq2(pChar("っても"), pFold("", pEmpty(), "EvenIf", -3)), pSeq2(pChar("って"), pFold("", pEmpty(), "And", -2))))
  //OOD 'た' ^ {/*-1*/{/*-1*/'' #} #WantTo}
  //OOD 'がち' ^ {/*-2*/{/*-2*/'' #} #xLikely}
  //OOD !MOOD1 ^ {'' #And}
  pRule(peg, "xVerbI", pOre(pSeq2(pAndChar("ま"), pRef(peg, "xPolite")), pSeq2(pSeq2(pChar("た"), pFold("", pNode(pEmpty(), "", -1), "WantTo", -1)), pRef(peg, "xAdj")), pSeq2(pFold("", pNode(pDict("やす よ"), "", 0), "EasyTo", 0), pRef(peg, "xAdj")), pSeq2(pFold("", pNode(pDict("にく がた づら"), "", 0), "HardTo", 0), pRef(peg, "xAdj")), pSeq2(pSeq2(pChar("がち"), pFold("", pNode(pEmpty(), "", -2), "xLikely", -2)), pOption(pRef(peg, "xNoun"))), pFold("", pNode(pDict("つつ ながら"), "", 0), "While", 0), pSeq2(pOre3(pRef(peg, "xNoun"), pRange("、，,\n", ""), pRef(peg, "EOF")), pFold("", pEmpty(), "Noun", 0)), pSeq2(pNotRange("まなるたれてず", ""), pFold("", pEmpty(), "And", 0))))
  //OOD 'ければ' ^ {/*-3*/{/*-3*/'' #} #If}
  //OOD 'くな' ^ {/*-2*/{/*-2*/'' #} #Not}
  //OOD 'くは' ^ {/*-2*/{/*-2*/'' #} &[なあ] #And}
  //OOD 'くに' ^ {/*-2*/{/*-2*/'' #} #Adverb}
  //OOD 'くても' ^ {/*-3*/{/*-3*/'' #} #EvenIf}
  //OOD 'く' ^ {/*-1*/{/*-1*/'て'? #} #And}
  //OOD 'い' ^ {/*-1*/{/*-1*/'' #} #Base}
  //OOD 'で' ^ {/*-1*/'' #And}
  //OOD 'かった' ^ {/*-3*/{/*-3*/'' #} #Past}
  //OOD 'さ' ^ {/*-1*/{/*-1*/'' #} #Noun}
  pRule(peg, "xAdj", pOre(pSeq2(pChar("ければ"), pFold("", pNode(pEmpty(), "", -3), "If", -3)), pSeq2(pSeq2(pChar("くな"), pFold("", pNode(pEmpty(), "", -2), "Not", -2)), pRef(peg, "xAdj")), pSeq2(pChar("くは"), pFold("", pSeq2(pNode(pEmpty(), "", -2), pAndRange("なあ", "")), "And", -2)), pSeq2(pChar("くに"), pFold("", pNode(pEmpty(), "", -2), "Adverb", -2)), pSeq2(pChar("くても"), pFold("", pNode(pEmpty(), "", -3), "EvenIf", -3)), pSeq2(pChar("く"), pFold("", pNode(pOptionChar("て"), "", -1), "And", -1)), pSeq2(pSeq2(pChar("い"), pFold("", pNode(pEmpty(), "", -1), "Base", -1)), pOption(pOre2(pSeq2(pChar("で"), pFold("", pEmpty(), "And", -1)), pRef(peg, "xBase")))), pSeq2(pSeq2(pChar("かった"), pFold("", pNode(pEmpty(), "", -3), "Past", -3)), pOption(pRef(peg, "xPast"))), pSeq2(pSeq2(pChar("さ"), pFold("", pNode(pEmpty(), "", -1), "Noun", -1)), pOption(pRef(peg, "xNoun")))))
  //OOD 'で' ^ {/*-1*/{/*-1*/'すら' / 'さえ' #} #Though}
  //OOD 'でな' ^ {/*-2*/{/*-2*/'' #} #IsNot}
  pRule(peg, "xBe", pOre(pSeq2(pChar("で"), pFold("", pNode(pDict("すら さえ"), "", -1), "Though", -1)), pSeq2(pSeq2(pChar("でな"), pFold("", pNode(pEmpty(), "", -2), "IsNot", -2)), pRef(peg, "xAdj")), pSeq2(pFold("", pNode(pDict("でしょう だろう"), "", 0), "WouldBe", 0), pOption(pRef(peg, "xBase"))), pSeq2(pFold("", pNode(pDict("でした だった"), "", 0), "Was", 0), pOption(pRef(peg, "xPast"))), pSeq2(pFold("", pNode(pOre3(pChar("です"), pChar("である"), pSeq2(pChar("だ"), pNotChar("け"))), "", 0), "Is", 0), pOption(pRef(peg, "xBase")))))
  //OOD 'する' ^ {/*-2*/'' #Let}
  //OOD 'して' ^ {/*-2*/'ください'? #Let}
  //OOD 'した' ^ {/*-2*/'' #Let}
  //OOD 'し' ^ {/*-1*/'' #Let}
  pRule(peg, "xLet", pOre4(pSeq2(pSeq2(pChar("する"), pFold("", pEmpty(), "Let", -2)), pOption(pRef(peg, "xBase"))), pSeq2(pSeq2(pChar("して"), pFold("", pOptionChar("ください"), "Let", -2)), pOption(pRef(peg, "xNounOf"))), pSeq2(pSeq2(pChar("した"), pFold("", pEmpty(), "Let", -2)), pOption(pRef(peg, "xPast"))), pSeq2(pSeq2(pChar("し"), pFold("", pEmpty(), "Let", -1)), pOre2(pRef(peg, "xMood"), pRef(peg, "xTen")))))
  //OOD 'まで' ^ {/*-2*/{/*-2*/'' #} #Until}
  //OOD 'へ' ^ {/*-1*/{/*-1*/'' #} #To}
  //OOD 'に' ^ {/*-1*/{/*-1*/'' #} (Against / About / xLet / By / Despite / xNounOf)? #Object}
  //OOD 'と' ^ {/*-1*/{/*-1*/'か'? #} #Object}
  //OOD 'で' ^ {/*-1*/{/*-1*/'' #} #Object}
  //OOD 'か' ^ {/*-1*/{/*-1*/'どうか' / '否か' #} #Whether}
  //OOD 'か' ^ {/*-1*/{/*-1*/'' #} #OrElse}
  //OOD 'らし' ^ {/*-2*/{/*-2*/'' #} #Likely}
  //OOD 'ごと' ^ {/*-2*/{/*-2*/'' #} #Each}
  //OOD 'など' ^ {/*-2*/{/*-2*/'' #} #Etc}
  //OOD 'そう' ^ {/*-2*/{/*-2*/'' #} #Seem}
  //OOD 'さ' ![せれ] ^ {/*-2*/{/*-2*/'' #} #Noun}
  //OOD 'なら' ^ {/*-2*/{/*-2*/'ば'? #} #If}
  //OOD 'な' ^ {/*-1*/{/*-1*/'' #} ![いくか] #Adjective}
  //OOD 'の' ^ {/*-1*/{/*-1*/'' #} #ThingThat}
  //OOD 'を' ^ {/*-1*/{/*-1*/'' #} #Object}
  //OOD 'や' ^ {/*-1*/{/*-1*/'' #} #AndOr}
  //OOD 'または' ^ {/*-3*/{/*-3*/'' #} #Or}
  pRule(peg, "xNoun2", pOre(pSeq2(pRef(peg, "BE"), pRef(peg, "xBe")), pRef(peg, "xMay"), pSeq2(pFold("", pNode(pDict("から より"), "", 0), "From", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("まで"), pFold("", pNode(pEmpty(), "", -2), "Until", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("へ"), pFold("", pNode(pEmpty(), "", -1), "To", -1)), pOption(pRef(peg, "xNounOf"))), pSeq2(pChar("に"), pFold("", pSeq2(pNode(pEmpty(), "", -1), pOption(pOre(pRef(peg, "Against"), pRef(peg, "About"), pRef(peg, "xLet"), pRef(peg, "By"), pRef(peg, "Despite"), pRef(peg, "xNounOf")))), "Object", -1)), pSeq2(pSeq2(pChar("と"), pFold("", pNode(pOptionChar("か"), "", -1), "Object", -1)), pOption(pOre2(pRef(peg, "xLet"), pRef(peg, "xNounOf")))), pSeq2(pSeq2(pChar("で"), pFold("", pNode(pEmpty(), "", -1), "Object", -1)), pOption(pOre2(pRef(peg, "xExist"), pRef(peg, "xNounOf")))), pSeq2(pFold("", pNode(pDict("かぎり 限り"), "", 0), "AsLong", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("か"), pFold("", pNode(pDict("どうか 否か"), "", -1), "Whether", -1)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("か"), pFold("", pNode(pEmpty(), "", -1), "OrElse", -1)), pOption(pRef(peg, "xNoun"))), pSeq2(pFold("", pNode(pDict("のみ だけ ばかり さえ"), "", 0), "Only", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("らし"), pFold("", pNode(pEmpty(), "", -2), "Likely", -2)), pRef(peg, "xAdj")), pSeq2(pSeq2(pChar("ごと"), pFold("", pNode(pEmpty(), "", -2), "Each", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("など"), pFold("", pNode(pEmpty(), "", -2), "Etc", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pFold("", pNode(pDict("なし なさ"), "", 0), "No", 0), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("そう"), pFold("", pNode(pEmpty(), "", -2), "Seem", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pSeq2(pChar("さ"), pNotRange("せれ", "")), pFold("", pNode(pEmpty(), "", -2), "Noun", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pChar("なら"), pFold("", pNode(pOptionChar("ば"), "", -2), "If", -2)), pSeq2(pSeq2(pChar("な"), pFold("", pSeq2(pNode(pEmpty(), "", -1), pNotRange("いくか", "")), "Adjective", -1)), pOption(pSeq3(pSeq2(pChar("の"), pFold("", pNode(pEmpty(), "", -1), "ThingThat", -1)), pNot(pRef(peg, "NOUN")), pRef(peg, "xNoun")))), pSeq2(pChar("を"), pFold("", pNode(pEmpty(), "", -1), "Object", -1)), pSeq2(pChar("や"), pFold("", pNode(pEmpty(), "", -1), "AndOr", -1)), pSeq2(pChar("または"), pFold("", pNode(pEmpty(), "", -3), "Or", -3)), pRef(peg, "xNounOf")))
  //OOD 'な' ^ {/*-1*/{/*-1*/'' #} #Not}
  //OOD 'ず' ^ {/*-1*/{/*-1*/'' #Not} #Noun}
  //OOD 'れ' ^ {/*-1*/{/*-1*/'' #} &MOOD1 #Been}
  pRule(peg, "xVerbA", pOre4(pSeq2(pSeq2(pChar("な"), pFold("", pNode(pEmpty(), "", -1), "Not", -1)), pRef(peg, "xAdj")), pSeq2(pSeq2(pChar("ず"), pFold("", pNode(pEmpty(), "Not", -1), "Noun", -1)), pOption(pRef(peg, "xNoun"))), pSeq2(pFold("", pNode(pSeq3(pOptionChar("さ"), pChar("せ"), pOptionChar("られ")), "", 0), "Make", 0), pRef(peg, "xMood")), pSeq2(pSeq2(pChar("れ"), pFold("", pSeq2(pNode(pEmpty(), "", -1), pAndRange("まなるたれてず", "")), "Been", -1)), pRef(peg, "xMood"))))
  //OOD 'た' ^ {/*-1*/{/*-1*/'' #} #WantTo}
  //OOD 'た' ^ {/*-1*/{/*-1*/'' #} #Past}
  //OOD 'てから' ^ {/*-3*/{/*-3*/'' #} #After}
  //OOD 'ても' ^ {/*-2*/{/*-2*/'' #} #EvenIf}
  //OOD 'て' ^ {/*-1*/{/*-1*/'' #} 'ください'? #And}
  pRule(peg, "xVerbIX", pOre(pSeq2(pSeq2(pChar("た"), pFold("", pNode(pEmpty(), "", -1), "WantTo", -1)), pRef(peg, "xAdj")), pSeq2(pSeq2(pChar("た"), pFold("", pNode(pEmpty(), "", -1), "Past", -1)), pOption(pRef(peg, "xPast"))), pSeq2(pChar("てから"), pFold("", pNode(pEmpty(), "", -3), "After", -3)), pSeq2(pChar("ても"), pFold("", pNode(pEmpty(), "", -2), "EvenIf", -2)), pSeq2(pSeq2(pChar("て"), pFold("", pSeq2(pNode(pEmpty(), "", -1), pOptionChar("ください")), "And", -1)), pOption(pRef(peg, "xTry")))))
  //OOD 'な' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'に' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ん' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ぬ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ね' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'の' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbNA5", pOre(pSeq2(pSeq2(pChar("な"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("に"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("ん"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIXD")), pSeq2(pSeq2(pChar("ぬ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("ね"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("の"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'ま' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'み' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ん' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'む' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'め' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'も' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbMA5", pOre(pSeq2(pSeq2(pChar("ま"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("み"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("ん"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIXD")), pSeq2(pSeq2(pChar("む"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("め"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("も"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'が' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ぎ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'い' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ぐ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'げ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ご' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbGA5", pOre(pSeq2(pSeq2(pChar("が"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("ぎ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("い"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIXD")), pSeq2(pSeq2(pChar("ぐ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("げ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("ご"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'ば' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'び' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ん' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ぶ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'べ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ぼ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbBA5", pOre(pSeq2(pSeq2(pChar("ば"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("び"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("ん"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIXD")), pSeq2(pSeq2(pChar("ぶ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("べ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("ぼ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'な' ^ {/*-1*/{/*-1*/'' #} #Not}
  //OOD 'る' ^ {/*-1*/{/*-1*/'' #} #Base}
  //OOD 'た' ^ {/*-1*/{/*-1*/'' #} #Past}
  //OOD 'ず' ^ {/*-1*/{/*-1*/'' #Not} #Noun}
  //OOD 'れば' ^ {/*-2*/{/*-2*/'' #} #If}
  //OOD 'てから' ^ {/*-3*/{/*-3*/'' #} #After}
  //OOD 'ても' ^ {/*-2*/{/*-2*/'' #} #EvenIf}
  //OOD 'て' ^ {/*-1*/'' #To}
  pRule(peg, "xMood", pOre(pSeq2(pAndChar("ま"), pRef(peg, "xPolite")), pSeq2(pSeq2(pChar("な"), pFold("", pNode(pEmpty(), "", -1), "Not", -1)), pRef(peg, "xAdj")), pSeq2(pSeq2(pChar("る"), pFold("", pNode(pEmpty(), "", -1), "Base", -1)), pOption(pRef(peg, "xBase"))), pSeq2(pSeq2(pChar("た"), pFold("", pNode(pEmpty(), "", -1), "Past", -1)), pOption(pRef(peg, "xPast"))), pSeq2(pSeq2(pChar("ず"), pFold("", pNode(pEmpty(), "Not", -1), "Noun", -1)), pOption(pRef(peg, "xNoun"))), pSeq2(pChar("れば"), pFold("", pNode(pEmpty(), "", -2), "If", -2)), pSeq2(pChar("てから"), pFold("", pNode(pEmpty(), "", -3), "After", -3)), pSeq2(pChar("ても"), pFold("", pNode(pEmpty(), "", -2), "EvenIf", -2)), pSeq2(pSeq2(pChar("て"), pFold("", pEmpty(), "To", -1)), pRef(peg, "xTry")), pSeq2(pFold("", pNode(pOptionChar("て"), "", 0), "And", 0), pOption(pRef(peg, "xTry")))))
  //OOD 'さ' !'れ' ^ {/*-2*/{/*-2*/'' #} #Noun}
  //OOD 'そう' ^ {/*-2*/{/*-2*/'' #} #Like}
  //OOD 'ならば' ^ {/*-3*/{/*-3*/'' #} #If}
  pRule(peg, "xAdjective", pOre4(pSeq2(pFold("", pNode(pDict("過ぎ すぎ"), "", 0), "Too", 0), pOption(pRef(peg, "xVerbHIRA1"))), pRef(peg, "xAdj"), pSeq2(pSeq2(pSeq2(pChar("さ"), pNotChar("れ")), pFold("", pNode(pEmpty(), "", -2), "Noun", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("そう"), pFold("", pNode(pEmpty(), "", -2), "Like", -2)), pOption(pOre2(pSeq2(pChar("ならば"), pFold("", pNode(pEmpty(), "", -3), "If", -3)), pRef(peg, "xNoun"))))))
  //OOD 'する' {/*-2*/'' #Do}
  //OOD 'す' {/*-1*/'' #Do}
  //OOD 'し' {/*-1*/'' #Do}
  //OOD 'され' {/*-2*/'' #Been}
  //OOD 'でき' {/*-2*/'' #Can}
  pRule(peg, "Do", pOre(pSeq2(pSeq2(pChar("する"), pNode(pEmpty(), "Do", -2)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("す"), pNode(pEmpty(), "Do", -1)), pSeq2(pChar("れ"), pRef(peg, "xVerbE"))), pRef(peg, "xShould"), pSeq2(pSeq2(pChar("し"), pNode(pEmpty(), "Do", -1)), pOre4(pRef(peg, "xVerbA"), pSeq2(pChar("よ"), pRef(peg, "xVerbO")), pRef(peg, "xVerbIX"), pRef(peg, "xVerbI"))), pSeq2(pSeq2(pChar("され"), pNode(pEmpty(), "Been", -2)), pRef(peg, "xMood")), pSeq2(pSeq2(pChar("でき"), pNode(pEmpty(), "Can", -2)), pRef(peg, "xMood"))))
  //OOD 'こ' {/*-1*/'' #Come}
  //OOD 'き' {/*-1*/'' #Come}
  //OOD 'くる' {/*-2*/'' #Come}
  //OOD 'くれ' {/*-2*/'' #Come}
  //OOD 'ば' ^ {/*-1*/'' #If}
  pRule(peg, "Come", pOre4(pSeq2(pSeq2(pChar("こ"), pNode(pEmpty(), "Come", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("き"), pNode(pEmpty(), "Come", -1)), pRef(peg, "xVerbIX")), pSeq2(pSeq2(pChar("くる"), pNode(pEmpty(), "Come", -2)), pOption(pRef(peg, "xBase"))), pSeq2(pSeq2(pChar("くれ"), pNode(pEmpty(), "Come", -2)), pSeq2(pChar("ば"), pFold("", pEmpty(), "If", -1)))))
  //OOD 'さ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'し' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'し' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'す' ^ {/*-1*/{/*-1*/'る'? #} #Verb}
  //OOD 'せ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'そ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbSA5", pOre(pSeq2(pSeq2(pChar("さ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("し"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIX")), pSeq2(pSeq2(pChar("し"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("す"), pFold("", pNode(pOptionChar("る"), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("せ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("そ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'た' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ち' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'っ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'つ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'て' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'と' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbTA5", pOre(pSeq2(pSeq2(pChar("た"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("ち"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("っ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIX")), pSeq2(pSeq2(pChar("つ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("て"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("と"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'ら' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'り' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'っ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'る' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'れ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'ろ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbRA5", pOre(pSeq2(pSeq2(pChar("ら"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("り"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("っ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIX")), pSeq2(pSeq2(pChar("る"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("れ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("ろ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'わ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'い' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'っ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'う' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'え' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'お' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbWA5", pOre(pSeq2(pSeq2(pChar("わ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("い"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("っ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIX")), pSeq2(pSeq2(pChar("う"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("え"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("お"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'か' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'き' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'い' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'く' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'け' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'こ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbKA5", pOre(pSeq2(pSeq2(pChar("か"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbA")), pSeq2(pSeq2(pChar("き"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbI")), pSeq2(pSeq2(pChar("い"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbIX")), pSeq2(pSeq2(pChar("く"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("け"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("こ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO"))))
  //OOD 'る' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'れ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'られ' ^ {/*-2*/{/*-2*/'' #} #Been}
  //OOD 'よ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerbHIRA1", pOre(pSeq2(pSeq2(pChar("る"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("れ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("られ"), pFold("", pNode(pEmpty(), "", -2), "Been", -2)), pRef(peg, "xMood")), pSeq2(pSeq2(pChar("よ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO")), pRef(peg, "xVerbA"), pRef(peg, "xVerbIX"), pRef(peg, "xVerbI")))
  //OOD [すず] 'る' ^ {/*-3*/{/*-3*/'' #} #Do}
  //OOD [すず] ^ {/*-1*/{/*-1*/'' #} #Do}
  //OOD [しじ] ^ {/*-1*/{/*-1*/'' #} #Do}
  //OOD 'され' ^ {/*-2*/{/*-2*/'' #} #Been}
  //OOD 'させ' ^ {/*-2*/{/*-2*/'' #} #Make}
  //OOD 'せず' ^ {/*-2*/{/*-2*/'' #Not} #Noun}
  //OOD 'でき' ^ {/*-2*/{/*-2*/'' #} #Can}
  pRule(peg, "xNounVerb", pOre(pSeq2(pSeq2(pSeq2(pRange("すず", ""), pChar("る")), pFold("", pNode(pEmpty(), "", -3), "Do", -3)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pRange("すず", ""), pFold("", pNode(pEmpty(), "", -1), "Do", -1)), pOre2(pSeq2(pChar("れ"), pRef(peg, "xVerbE")), pRef(peg, "xShould"))), pSeq2(pSeq2(pRange("しじ", ""), pFold("", pNode(pEmpty(), "", -1), "Do", -1)), pOre4(pRef(peg, "xVerbA"), pSeq2(pChar("よ"), pRef(peg, "xVerbO")), pRef(peg, "xVerbIX"), pRef(peg, "xVerbI"))), pSeq2(pSeq2(pChar("され"), pFold("", pNode(pEmpty(), "", -2), "Been", -2)), pRef(peg, "xMood")), pSeq2(pSeq2(pChar("させ"), pFold("", pNode(pEmpty(), "", -2), "Make", -2)), pRef(peg, "xMood")), pSeq2(pSeq2(pChar("せず"), pFold("", pNode(pEmpty(), "Not", -2), "Noun", -2)), pOption(pRef(peg, "xNoun"))), pSeq2(pSeq2(pChar("でき"), pFold("", pNode(pEmpty(), "", -2), "Can", -2)), pRef(peg, "xMood"))))
  //OOD 'み' ^ {/*-1*/xMood #TryTo}
  //OOD 'い' ^ {/*-1*/'' #Going}
  //OOD 'い' ^ {/*-1*/xMood #Now}
  pRule(peg, "xTry", pOre(pSeq2(pChar("み"), pFold("", pRef(peg, "xMood"), "TryTo", -1)), pSeq2(pSeq2(pChar("い"), pFold("", pEmpty(), "Going", -1)), pRef(peg, "xVerbKA5")), pSeq2(pChar("い"), pFold("", pRef(peg, "xMood"), "Now", -1)), pRef(peg, "xExist"), pRef(peg, "Come")))
  pRule(peg, "NounChunk", pOre4(pSeq2(pRef(peg, "Code"), pOption(pRef(peg, "xNoun"))), pSeq2(pRef(peg, "NewNoun"), pOption(pOre3(pRef(peg, "xNounVerb"), pRef(peg, "xVerbRA5"), pRef(peg, "xNoun")))), pSeq2(pRef(peg, "DefNoun"), pOption(pOre2(pRef(peg, "xNounVerb"), pRef(peg, "xNoun")))), pSeq2(pRef(peg, "PatNoun"), pOption(pOre3(pRef(peg, "xNounVerb"), pRef(peg, "xVerbRA5"), pRef(peg, "xNoun"))))))
  pRule(peg, "VerbChunk", pOre(pRef(peg, "Exist"), pRef(peg, "Do"), pRef(peg, "Come"), pSeq2(pRef(peg, "VerbKA5"), pRef(peg, "xVerbKA5")), pSeq2(pRef(peg, "VerbSA5"), pRef(peg, "xVerbSA5")), pSeq2(pRef(peg, "VerbTA5"), pRef(peg, "xVerbTA5")), pSeq2(pRef(peg, "VerbNA5"), pRef(peg, "xVerbNA5")), pSeq2(pRef(peg, "VerbMA5"), pRef(peg, "xVerbMA5")), pSeq2(pRef(peg, "VerbRA5"), pRef(peg, "xVerbRA5")), pSeq2(pRef(peg, "VerbWA5"), pRef(peg, "xVerbWA5")), pSeq2(pRef(peg, "VerbGA5"), pRef(peg, "xVerbGA5")), pSeq2(pRef(peg, "VerbBA5"), pRef(peg, "xVerbBA5")), pSeq2(pRef(peg, "Verb1"), pRef(peg, "xVerb1"))))
  //OOD 'る' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'れ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  //OOD 'られ' ^ {/*-2*/{/*-2*/'' #} #Been}
  //OOD 'よ' ^ {/*-1*/{/*-1*/'' #} #Verb}
  pRule(peg, "xVerb1", pOre(pSeq2(pSeq2(pChar("る"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbU")), pSeq2(pSeq2(pChar("れ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbE")), pSeq2(pSeq2(pChar("られ"), pFold("", pNode(pEmpty(), "", -2), "Been", -2)), pRef(peg, "xMood")), pSeq2(pSeq2(pChar("よ"), pFold("", pNode(pEmpty(), "", -1), "Verb", -1)), pRef(peg, "xVerbO")), pRef(peg, "xVerbA"), pRef(peg, "xVerbIX"), pSeq2(pAndRange("", "ぁん"), pRef(peg, "xVerbI")), pSeq2(pFold("", pEmpty(), "And", 0), pRef(peg, "VerbChunk"))))
  pRule(peg, "Chunk", pOre(pRef(peg, "Adword"), pRef(peg, "Measure"), pRef(peg, "NounChunk0"), pRef(peg, "AdjectiveChunk"), pRef(peg, "VerbChunk"), pRef(peg, "NounChunk")))
  return peg;
}

const G = CJ({})
console.log(G)
PAsm.example(G, 'Sentence', '赤い')
PAsm.example(G, 'Sentence', 'とても赤い')
